.386
.model flat, stdcall

assume fs:NOTHING

.code
start:
	push ebp
	mov ebp,esp
	sub esp, 40h
	
	push ebp
	push 0
	push 0
	push 0
	push handler
	push fs:[0]
	mov fs:[0],esp
	
	mov eax, 10
	
	xor edx, edx
	xor ecx, ecx
	
div_:
	div ecx

	ret 			;terminate
	
	
handler:
	mov ebx, [esp+4]			;get EXCEPTION_RECORD address
	mov eax, [ebx+4]			;get exception flag
	cmp eax,0				;is it a continuable exception?
	jne _end
	
	mov eax,[ebx]			;get exception code
	cmp eax, 0C0000094h 		;is it the "divide by zero" error?
	je div0_
	mov eax, 1			;we can't fix it
	jmp _end				;so return to windows
	
div0_:	
	mov esi,[esp+0Ch]			;get CONTEXT address
	add esi,0ACh			;locate the ecx area
	mov dword ptr [esi],2h		;ecx=1
		
fix_eip:
	mov edi, [esp+0Ch]			;get CONTEXT address
	add edi, 0B8h			;goto eip register
	mov [edi], div_			;eip=div_
	mov eax,0				;reload context & continue execution
_end:
	ret

end start